package com.qs.mp.web.controller.api.admin;

import com.qs.mp.admin.domain.param.CouponPkgParam;
import com.qs.mp.admin.service.ICouponPkgService;
import com.qs.mp.common.core.domain.AjaxResult;
import com.qs.mp.web.controller.common.BaseApiController;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

/**
 * 券包管理API
 *
 * @author Cup
 * @date 2022/5/6
 */
@Api(tags = "券包管理API")
@RestController
@RequestMapping("/api/v1/mp/admin/coupon/pkg/*")
public class CouponPkgMgrController extends BaseApiController {


    @Autowired
    private ICouponPkgService couponPkgService;

    @PostMapping("/create")
    @ApiOperation("创建券包")
    public AjaxResult create(@RequestBody CouponPkgParam couponPkgParam) {

        couponPkgService.create(couponPkgParam);

        return AjaxResult.success();
    }


}
