package com.qs.mp.admin.service.impl;

import com.baomidou.mybatisplus.core.toolkit.CollectionUtils;
import com.qs.mp.admin.domain.CouponPkg;
import com.qs.mp.admin.domain.CouponPkgItem;
import com.qs.mp.admin.domain.param.CouponPkgItemParam;
import com.qs.mp.admin.domain.param.CouponPkgParam;
import com.qs.mp.admin.mapper.CouponPkgMapper;
import com.qs.mp.admin.service.ICouponPkgItemService;
import com.qs.mp.admin.service.ICouponPkgService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.qs.mp.common.exception.ServiceException;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.ArrayList;
import java.util.List;

/**
 * <p>
 * 券包表 服务实现类
 * </p>
 *
 * @author quanshu
 * @since 2022-04-29
 */
@Service
public class CouponPkgServiceImpl extends ServiceImpl<CouponPkgMapper, CouponPkg> implements ICouponPkgService {

    @Autowired
    private ICouponPkgItemService couponPkgItemService;


    @Override
    @Transactional(rollbackFor = Exception.class)
    public boolean create(CouponPkgParam couponPkgParam) {

        List<CouponPkgItemParam> couponPkgItemList = couponPkgParam.getCouponPkgItemList();
        if (CollectionUtils.isEmpty(couponPkgItemList)) {
            throw new ServiceException("券包明细不能为空");
        }

        CouponPkg couponPkg = new CouponPkg();
        BeanUtils.copyProperties(couponPkgParam, couponPkg);
        this.save(couponPkg);

        List<CouponPkgItem> params = new ArrayList<>();
        for (CouponPkgItemParam couponPkgItemParam : couponPkgItemList) {
            CouponPkgItem param = new CouponPkgItem();
            param.setCouponPkgId(couponPkg.getId());
            param.setCouponId(couponPkgItemParam.getCouponId());
            params.add(param);
        }
        couponPkgItemService.saveBatch(params);

        return true;
    }
}
